import base64

from gmssl import sm4


class CryptSM4:
    def __init__(self, key):
        self.crypt_sm4 = sm4.CryptSM4()  # 实例化
        self.key = key

    def encryptSM4(self, value):
        crypt_sm4 = self.crypt_sm4
        crypt_sm4.set_key(self.key.encode(), sm4.SM4_ENCRYPT)  # 设置密钥
        date_str = str(value)
        encrypt_value = crypt_sm4.crypt_ecb(date_str.encode())  # 开始加密。bytes类型
        return base64.b64encode(encrypt_value).decode()

    def decryptSM4(self, encrypt_value):
        crypt_sm4 = self.crypt_sm4
        crypt_sm4.set_key(self.key.encode(), sm4.SM4_DECRYPT)  # 设置密钥
        decrypt_value = crypt_sm4.crypt_ecb(base64.b64decode(encrypt_value))  # 开始解密。十六进制类型
        return decrypt_value.decode()
